----------------------------------------------------------------------------
-----  AddOn:			ReadySetDing								--------		----> Insert some Warcraft 3 [Steam Tank] ASCII Art here ! <----
-----  Author:			Ketho (EU-Boulderfist Alliance CHN)			--------		   http://classic.battle.net/war3/human/units/siegeengine.shtml
-----  Creation Date:	2010.01.04 (4 Januari 2010)					--------						(It's called Siege Engine)
-----  Text Editor:		Notepad++									--------
----------------------------------------------------------------------------
-----  # Description:												--------
-----  This AddOn's purpose is to compare leveling speed			--------
-----   and make Leveling it more competitive						--------
-----  # Features:													--------
-----  01) Announce Time Taken for Ding								--------
-----  02) Compare Leveling Speed									--------
----------------------------------------------------------------------------
-----  # Version													--------
-----  ReadySetDing								v0.3 [2010.01.28]	--------	http://wow.curse.com/downloads/wow-addons/details/readysetding.aspx
-----  Ace3 Development Framework				r907 [2009.12.16]	--------	http://wow.curse.com/downloads/wow-addons/details/ace3.aspx
----------------------------------------------------------------------------
-----  # Sites														--------
-----  Notepad++													--------	http://notepad-plus.sourceforge.net/
-----  Google														--------	http://www.google.com/
-----  WoWWiki														--------	http://www.wowwiki.com/
-----  World of Warcraft Programming								--------	http://wowprogramming.com/
-----  WowAce														--------	http://www.wowace.com/
-----  Wowhead														--------	http://www.wowhead.com/
----------------------------------------------------------------------------
-- 01) INITIALIZATION: OPTIONS AND DEFAULTS							--------
-- 02) INITIALIZATION: FUNCTIONS & CALLBACK HANDLERS				--------
-- 03) WORKLOAD														--------
----------------------------------------------------------------------------
--- # ToDo:
-- 03) Announce total time at lv80; 
-- 05) Party member ding (+gz)
-- 06) Filter /played message
-- 06) Total Time Played
------------------------------------------------------------------------------------------------------------------------------------------------------------------------

--- Instance of AceAddon Class  ---
ReadySetDing = LibStub("AceAddon-3.0"):NewAddon("ReadySetDing", "AceConsole-3.0", "AceEvent-3.0")

-- 01) INITIALIZATION: OPTIONS AND DEFAULTS
--- Blizzard GUI Options ---
local options = {
    name = "ReadySet\124cffFFFFFFDing\124r \124cffB6CA00v0.3\124r \124TInterface\\Icons\\Spell_Holy_BorrowedTime:20\124t", -- Position: TopLeft Corner of ReadySetDing Options; <version>
    handler = ReadySetDing,
    type = 'group',
    args = {
		toggleEnableAddOn = {
			type = "toggle",
			order = 1,
			name = "\124cffFBDB00Enable\124r AddOn",
			descStyle = "no tooltip plz",
			width = "double",
			get = "GetEnableAddOn",
			set = "SetEnableAddOn",
		},
		toggleNormalAnnounce = {
            type = "toggle",
			order = 2,
            name = "Announce to Say/\124cff7E74BBParty\124r\124r",
			width = "full",
			descStyle = "no tooltip plz",
			disabled = "OptionsDisabled",
            get = "GetNormalAnnounce",
            set = "SetNormalAnnounce",
		},
		toggleGuildAnnounce = {
            type = "toggle",
			order = 3,
			width = "full",
            name = "Announce to \124cff42E33DGuild\124r",
			descStyle = "no tooltip plz",
			disabled = "OptionsDisabled",
            get = "GetGuildAnnounce",
            set = "SetGuildAnnounce",
		},
		toggleTotalTimePlayed = {
            type = "toggle",
			order = 4,
			width = "full",
            name = "Include Total Time Played",
			descStyle = "no tooltip plz",
			disabled = "OptionsDisabled",
            get = "GetTotalTimePlayed",
            set = "SetTotalTimePlayed",
		},
--[[
		inputDingMessage = {
            type = "input",
			order = 6,
			width  = "full",
            name = "Ding Message",
            desc = "The ding message to be announced.",
            usage = "<Your message here>",
			disabled = "OptionsDisabled",
            get = "GetInputDingMessage",
            set = "SetInputDingMessage",
        },
--]]
		header01 = {
			type = "header",
			order = 5,
			name = "",
		},
		description01 = {
			type = "description",
			order = 6,
			name = "\124cffB6CA00Commands:\124r /RSD,  /RDY,  /readysetding",
		},
		description02 = {
			type = "description",
			order = 7,
			name = "\124cffB6CA00Example A:\124r Ding! Level 24 in 1 hour, 43 minutes.",
		},
		description03 = {
			type = "description",
			order = 8,
			name = "\124cffB6CA00Example B:\124r Ding! Level 24 in 1 hour, 43 minutes. (2 days, 11 hours Total Time)",
		},
		header02 = {
			type = "header",
			order = 9,
			name = "",
		},
		executeReset = {
			type = "execute",
			order = 10,
			confirm = true,
			confirmText = "Reset to Defaults? \124TInterface\\Icons\\INV_Misc_Rune_01:18\124t",
			name = "\124cffFFFFFFReset to Defaults\124r",
			func = "ResetOptions",
		},
    },
}

--- Blizzard GUI Defaults ---
local defaults = {
    profile = {
        enableAddOn = true,								-- 01
        normalAnnounce = true,							-- 02
        guildAnnounce = false,							-- 03
        totalTimePlayed = false,						-- 04
	--	dingMessage = "Ding! Level [x] in [timeDing]",	-- 06*
    },
}

-- "OptionsDisabled()" Callback Handler -- Complete disabling(gray out) of options ~~
function ReadySetDing:OptionsDisabled() -- 01A optionsDisabled
	if (ReadySetDing:GetEnableAddOn(info) == true) then return false;
	elseif (ReadySetDing:GetEnableAddOn(info) == false) then return true;
	end
end
--- "ResetOptions" Callback Handler		--- 10
function ReadySetDing:ResetOptions()					---- These numbers r just like a system to keep it a bit in order ...
--	self.db.profile.enableAddOn = true;					-- 01 lol wierd if i default reset an addon to either on/off
	self.db.profile.normalAnnounce = true;				-- 02
	self.db.profile.guildAnnounce = false;				-- 03
	self.db.profile.totalTimePlayed = false;			-- 04
--	self.db.profile.dingMessage = "Ding! Level [x] in [timeDing]";	-- 06 input
end

--- Blizzard GUI Options GET/SET Handlers ---
function ReadySetDing:GetEnableAddOn(info) -- 01 enableAddOn GET
	return self.db.profile.enableAddOn
end
function ReadySetDing:SetEnableAddOn(info, value) -- 01 enableAddOn SET
	self.db.profile.enableAddOn = value
	if (self.db.profile.enableAddOn == true) and (notDing_totalTimeLevel == nil) then	RequestTimePlayed(); -- fetch "timePlayed" if Player decides to enable AddOn again
	end
end
function ReadySetDing:GetNormalAnnounce(info) -- 02 normalAnnounce GET
    return self.db.profile.normalAnnounce
end
function ReadySetDing:SetNormalAnnounce(info, value) -- 02 normalAnnounce SET
    self.db.profile.normalAnnounce = value
end
function ReadySetDing:GetGuildAnnounce(info) -- 03 guildAnnounce GET
    return self.db.profile.guildAnnounce
end
function ReadySetDing:SetGuildAnnounce(info, value) -- 03 guildAnnounce SET
    self.db.profile.guildAnnounce = value
end
function ReadySetDing:GetTotalTimePlayed(info) -- 04 totalTimePlayed GET
    return self.db.profile.totalTimePlayed
end
function ReadySetDing:SetTotalTimePlayed(info, value) -- 04 totalTimePlayed SET
    self.db.profile.totalTimePlayed = value
end
--[[
function ReadySetDing:GetInputDingMessage(info) -- 06 dingMessage GET
    return self.db.profile.dingMessage
end
function ReadySetDing:SetInputDingMessage(info, newValue) -- 06 dingMessage SET
    self.db.profile.dingMessage = newValue
end
--]]
------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- 02) INITIALIZATION: FUNCTIONS & CALLBACK HANDLERS

function ReadySetDing:OnInitialize()
	-- Called when the addon is loaded
	self.db = LibStub("AceDB-3.0"):New("ReadySetDingDB", defaults, "Default")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("ReadySetDing", options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("ReadySetDing", "ReadySet\124cffFFFFFFDing\124r \124TInterface\\Icons\\Spell_Holy_BorrowedTime:18\124t") -- Position: In Blizzard AddOn Options List; <Icon>

--- Subscribe to Events ---
	self:RegisterEvent("PLAYER_LEVEL_UP")
	self:RegisterEvent("TIME_PLAYED_MSG")
--	self:RegisterEvent("GUILD_ROSTER_UPDATE")
	self:RegisterEvent("PARTY_MEMBERS_CHANGED")

--- /Slash Commands ---
	self:RegisterChatCommand("rsd", "BlizzOptions")
--	self:RegisterChatCommand("rsdtest", "testMessage") -- test
	self:RegisterChatCommand("rdy", "BlizzOptions")
	self:RegisterChatCommand("readyset", "BlizzOptions")
	self:RegisterChatCommand("readysetding", "BlizzOptions")

--- Variables ---
	playerDinged = false;
	
--- Settings ---
	SetCVar("cameraDistanceMax",50); -- Max Camera Distance ...
	
--- Not yet Implemented ---
	-- UnitXP("unit")
	-- UnitXPMax("unit")
	-- GetGuildRosterInfo(index)
	-- GetGuildRosterSelection()
	-- GetNumGuildMembers(offline)
	-- GuildRoster()
	-- IsGuildLeader("name")
	-- SetGuildRosterSelection(index)
	-- SortGuildRoster("sort")
end

function ReadySetDing:OnEnable()
	-- Called when the addon is enabled

--- Player Info ---
	playerName = UnitName("player"); -- Name of Player
--	englishFactionPlayer, localizedFactionPlayer = UnitFactionGroup("player");	-- Faction of Player
--	localizedClassPlayer, englishClassPlayer = UnitClass("player");	-- Class of Player
	playerLevel = UnitLevel("player"); -- Level of Player

-- Player Class Colour -- dont want to keep requerying for that
	if		(englishClassPlayer == "WARRIOR") then		playerClassHEX = "C79C6E"; -- Class Colours (HEX) taken from: http://www.wowwiki.com/Class
	elseif	(englishClassPlayer == "PALADIN") then		playerClassHEX = "F58CBA";
	elseif	(englishClassPlayer == "DRUID") then		playerClassHEX = "FF7D0A";
	elseif	(englishClassPlayer == "DEATHKNIGHT") then	playerClassHEX = "C41F3B";
	elseif	(englishClassPlayer == "ROGUE") then		playerClassHEX = "FFF569";
	elseif	(englishClassPlayer == "HUNTER") then		playerClassHEX = "ABD473";
	elseif	(englishClassPlayer == "SHAMAN") then		playerClassHEX = "2459FF";
	elseif	(englishClassPlayer == "PRIEST") then		playerClassHEX = "FFFFFF";
	elseif	(englishClassPlayer == "MAGE") then			playerClassHEX = "69CCF0";
	elseif	(englishClassPlayer == "WARLOCK") then		playerClassHEX = "9482C9";
	else playerClassHEX = "FFFFFF"; -- white ~~
	end

--- Guild Info ---
	numGuildMembers = GetNumGuildMembers();

--- Level Check & timePlayed Variable ---
	if (playerLevel == 80) or (playerLevel == 85) then	enableAddOn = false;
	else	if (ReadySetDing:GetEnableAddOn(info) == true) then	RequestTimePlayed();	-- First timePlayed variable (disabled+noSpam for LV80/LV85)
			end
	end
end

function ReadySetDing:OnDisable()
	-- Called when the addon is disabled
	
--- Unsubscribe from Events (redundant with Ace3 ?) ---
    self:UnRegisterEvent("PLAYER_LEVEL_UP")
	self:UnRegisterEvent("TIME_PLAYED_MSG")
--	self:UnRegisterEvent("GUILD_ROSTER_UPDATE")
	self:UnRegisterEvent("PARTY_MEMBERS_CHANGED")
	
	self:Print("\124cffFFFF3F[ReadySetDing]\124r: Disabled (OnDisable)")
end
--- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- ---
function ReadySetDing:BlizzOptions(input)
	-- Process the slash command ('input' contains whatever follows the slash command)
	if not input or input:trim() == "" then
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
--	else
--		LibStub("AceConfigCmd-3.0").HandleCommand(ReadySetDing, "ReadySetDing", "rsd", input)
	end
end
--[[
function ReadySetDing:testMessage() -- test .. mayb something with "string find" and "replace" stuff ..
	timeDing = ((totalTimeLevel - notDing_totalTimeLevel) + notDing_currentTimeLevel);
	SendChatMessage(ReadySetDing:GetInputDingMessage(info).." "..playerLevel.." "..timeDing.."", "SAY");
end
--]]
--- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- ---
--- Callback Handler:timeToString() --- most significant 2 Units of Time 
function timeToString(time)
	local seconds = mod(floor(time),60);
	local minutes = mod(floor(time/60),60);
	local hours = mod(floor(time/3600),24);
	local days = floor(time/(86400));
	if (time < 60) then
		if		(seconds ~= 1)					then return ""..seconds.." seconds";
		elseif	(seconds == 1)					then return ""..seconds.." second"; -- mayb if some1 uses Recruit-a-Friend(RAF) level granting
		elseif	(seconds == 0)					then return "an instant"; -- lol
		end
	elseif (time >= 60 and time < 3600) then
		if		(minutes ~= 1 and seconds ~= 1)	then return ""..minutes.." minutes, "..seconds.." seconds";
		elseif	(minutes == 1 and seconds ~= 1)	then return ""..minutes.." minute, "..seconds.." seconds";
		elseif	(minutes ~= 1 and seconds == 1)	then return ""..minutes.." minutes, "..seconds.." second";
		elseif	(minutes == 1 and seconds == 1)	then return ""..minutes.." minute, "..seconds.." second";
		end
	elseif (time >= 3600 and time < 86400) then
		if		(hours ~= 1 and minutes ~= 1)	then return ""..hours.." hours, "..minutes.." minutes";
		elseif	(hours == 1 and minutes ~= 1)	then return ""..hours.." hour, "..minutes.." minutes";
		elseif	(hours ~= 1 and minutes == 1)	then return ""..hours.." hours, "..minutes.." minute";
		elseif	(hours == 1 and minutes == 1)	then return ""..hours.." hour, "..minutes.." minute";
		end
	elseif (time >= 86400) then
		if		(days ~= 1 and hours ~= 1)		then return ""..days.." days, "..hours.." hours";
		elseif	(days == 1 and hours ~= 1)		then return ""..days.." day, "..hours.." hours";
		elseif	(days ~= 1 and hours == 1)		then return ""..days.." days, "..hours.." hour";
		elseif	(days == 1 and hours == 1)		then return ""..days.." day, "..hours.." hour";
		end
	end
end

--- Event Handler: "PARTY_MEMBERS_CHANGED" ---
function ReadySetDing:PARTY_MEMBERS_CHANGED()
	numPartyMembers = GetNumPartyMembers();
end
----------------------------------------------------------------------------------------------------------------------------------------------------------------------
function ReadySetDing:PLAYER_LEVEL_UP(event, ...)
	PLU_level, PLU_hp, PLU_mp, PLU_talentPoints, PLU_strength, PLU_agility, PLU_stamina, PLU_intellect, PLU_spirit = select(1, ...);
	if (ReadySetDing:GetEnableAddOn(info) == true) then -- [ON / OFF] Check
		playerDinged = true; RequestTimePlayed(); --> "TIME_PLAYED_MSG" event
	end
end

function ReadySetDing:TIME_PLAYED_MSG(event, ...)
	totalTimeLevel, currentTimeLevel = select(1, ...);
	if (ReadySetDing:GetEnableAddOn(info) == true) then -- [ON / OFF] Check
		if (playerDinged == false) then notDing_totalTimeLevel = totalTimeLevel; notDing_currentTimeLevel = currentTimeLevel;
		elseif (playerDinged == true) and ((currentTimeLevel >= 0) and (currentTimeLevel <= 5)) and (notDing_totalTimeLevel) and (notDing_currentTimeLevel) then
			timeDing = ((totalTimeLevel - notDing_totalTimeLevel) + notDing_currentTimeLevel); --  the formula ..
			if		(ReadySetDing:GetTotalTimePlayed(info) == false) then	totalTimeLevelOption = "";
			elseif	(ReadySetDing:GetTotalTimePlayed(info) == true) then	totalTimeLevelOption = " ("..timeToString(totalTimeLevel).." Total Time)";
			end
			if ((select(2, IsInInstance())) == "none") and (ReadySetDing:GetNormalAnnounce(info) == true) then
				if (numPartyMembers) and (numPartyMembers >= 1) then	SendChatMessage("Ding! Level "..PLU_level.." in "..timeToString(timeDing).."."..totalTimeLevelOption.."", "PARTY");
				else	SendChatMessage("Ding! Level "..PLU_level.." in "..timeToString(timeDing).."."..totalTimeLevelOption.."", "SAY");
				end
			elseif ((select(2, IsInInstance())) == "party") and (ReadySetDing:GetNormalAnnounce(info) == true) then	SendChatMessage("Ding! Level "..PLU_level.." in "..timeToString(timeDing).."."..totalTimeLevelOption.."", "PARTY");
			elseif ((select(2, IsInInstance())) == "raid") and (ReadySetDing:GetNormalAnnounce(info) == true) then	SendChatMessage("Ding! Level "..PLU_level.." in "..timeToString(timeDing).."."..totalTimeLevelOption.."", "RAID");
			elseif ((select(2, IsInInstance())) == "pvp") and (ReadySetDing:GetBattlegroundAnnounce(info) == true) then	SendChatMessage("Ding! Level "..PLU_level.." in "..timeToString(timeDing).."."..totalTimeLevelOption.."", "BATTLEGROUND");
			end
			if (ReadySetDing:GetGuildAnnounce(info) == true) and (IsInGuild() == 1) then	SendChatMessage("Ding! Level "..PLU_level.." in "..timeToString(timeDing).."."..totalTimeLevelOption.."", "GUILD");
			end
			if (ReadySetDing:GetNormalAnnounce(info) == false) and (ReadySetDing:GetGuildAnnounce(info) == false or IsInGuild() ~= 1) then
				ChatFrame1:AddMessage("\124cff"..playerClassHEX.."You\124r Dinged Level "..PLU_level.." in "..timeToString(timeDing).."!"..totalTimeLevelOption.."");
			end
			playerDinged = false; notDing_totalTimeLevel = totalTimeLevel; notDing_currentTimeLevel = currentTimeLevel;
		--	ChatFrame1:AddMessage("Total time played: "..totalTimeLevel..", Time played this level: "..currentTimeLevel.."");
		end
	end
end

--[[
function ReadySetDing:GUILD_ROSTER_UPDATE()
	if (IsInGuild() == 1) then
		for i = 1, numGuildMembers do
			local GGRI_name, GGRI_rank, GGRI_rankIndex, GGRI_level, GGRI_class, GGRI_zone, GGRI_note, GGRI_officernote, GGRI_online, GGRI_status, GGRI_classFileName = GetGuildRosterInfo(i);
			GuildRosterInfo = GGRI_name.."["..i.."]-"..GGRI_level;
		--	savedNameLevel..i = GGRI_name.."-"..GGRI_level;
		end
	end
end
--]]
-------- END OF ADDON --------